<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/serde_derive-1.0.140/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../serde_derive/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
</pre><pre class="rust"><code><span class="doccomment">//! This crate provides Serde&#39;s two derive macros.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```edition2018</span>
<span class="doccomment">//! # use serde_derive::{Serialize, Deserialize};</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! #[derive(Serialize, Deserialize)]</span>
<span class="doccomment">//! # struct S;</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! # fn main() {}</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Please refer to [https://serde.rs/derive.html] for how to set this up.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [https://serde.rs/derive.html]: https://serde.rs/derive.html</span>

<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/serde_derive/1.0.140&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">unknown_lints</span>, <span class="ident">bare_trait_objects</span>)]</span>
<span class="comment">// Ignored clippy lints</span>
<span class="attribute">#![<span class="ident">allow</span>(
    <span class="comment">// clippy false positive: https://github.com/rust-lang/rust-clippy/issues/7054</span>
    <span class="ident">clippy::branches_sharing_code</span>,
    <span class="ident">clippy::cognitive_complexity</span>,
    <span class="comment">// clippy bug: https://github.com/rust-lang/rust-clippy/issues/7575</span>
    <span class="ident">clippy::collapsible_match</span>,
    <span class="ident">clippy::derive_partial_eq_without_eq</span>,
    <span class="ident">clippy::enum_variant_names</span>,
    <span class="comment">// clippy bug: https://github.com/rust-lang/rust-clippy/issues/6797</span>
    <span class="ident">clippy::manual_map</span>,
    <span class="ident">clippy::match_like_matches_macro</span>,
    <span class="ident">clippy::needless_pass_by_value</span>,
    <span class="ident">clippy::too_many_arguments</span>,
    <span class="ident">clippy::trivially_copy_pass_by_ref</span>,
    <span class="ident">clippy::used_underscore_binding</span>,
    <span class="ident">clippy::wildcard_in_or_patterns</span>,
    <span class="comment">// clippy bug: https://github.com/rust-lang/rust-clippy/issues/5704</span>
    <span class="ident">clippy::unnested_or_patterns</span>,
)]</span>
<span class="comment">// Ignored clippy_pedantic lints</span>
<span class="attribute">#![<span class="ident">allow</span>(
    <span class="ident">clippy::cast_possible_truncation</span>,
    <span class="ident">clippy::checked_conversions</span>,
    <span class="ident">clippy::doc_markdown</span>,
    <span class="ident">clippy::enum_glob_use</span>,
    <span class="ident">clippy::indexing_slicing</span>,
    <span class="ident">clippy::items_after_statements</span>,
    <span class="ident">clippy::let_underscore_drop</span>,
    <span class="ident">clippy::manual_assert</span>,
    <span class="ident">clippy::map_err_ignore</span>,
    <span class="ident">clippy::match_same_arms</span>,
    <span class="comment">// clippy bug: https://github.com/rust-lang/rust-clippy/issues/6984</span>
    <span class="ident">clippy::match_wildcard_for_single_variants</span>,
    <span class="ident">clippy::module_name_repetitions</span>,
    <span class="ident">clippy::must_use_candidate</span>,
    <span class="ident">clippy::option_if_let_else</span>,
    <span class="ident">clippy::similar_names</span>,
    <span class="ident">clippy::single_match_else</span>,
    <span class="ident">clippy::struct_excessive_bools</span>,
    <span class="ident">clippy::too_many_lines</span>,
    <span class="ident">clippy::unseparated_literal_suffix</span>,
    <span class="ident">clippy::unused_self</span>,
    <span class="ident">clippy::use_self</span>,
    <span class="ident">clippy::wildcard_imports</span>
)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">all</span>(<span class="ident">test</span>, <span class="ident">exhaustive</span>), <span class="ident">feature</span>(<span class="ident">non_exhaustive_omitted_patterns_lint</span>))]</span>

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">quote</span>;
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">syn</span>;

<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">proc_macro</span>;
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">proc_macro2</span>;

<span class="kw">mod</span> <span class="ident">internals</span>;

<span class="kw">use</span> <span class="ident">proc_macro::TokenStream</span>;
<span class="kw">use</span> <span class="ident">syn::DeriveInput</span>;

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">mod</span> <span class="ident">bound</span>;
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">mod</span> <span class="ident">fragment</span>;

<span class="kw">mod</span> <span class="ident">de</span>;
<span class="kw">mod</span> <span class="ident">dummy</span>;
<span class="kw">mod</span> <span class="ident">pretend</span>;
<span class="kw">mod</span> <span class="ident">ser</span>;
<span class="kw">mod</span> <span class="ident">try</span>;

<span class="attribute">#[<span class="ident">proc_macro_derive</span>(<span class="ident">Serialize</span>, <span class="ident">attributes</span>(<span class="ident">serde</span>))]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">derive_serialize</span>(<span class="ident">input</span>: <span class="ident">TokenStream</span>) -&gt; <span class="ident">TokenStream</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">input</span> <span class="op">=</span> <span class="macro">parse_macro_input!</span>(<span class="ident">input</span> <span class="kw">as</span> <span class="ident">DeriveInput</span>);
    <span class="ident">ser::expand_derive_serialize</span>(<span class="kw-2">&amp;mut</span> <span class="ident">input</span>)
        .<span class="ident">unwrap_or_else</span>(<span class="ident">to_compile_errors</span>)
        .<span class="ident">into</span>()
}

<span class="attribute">#[<span class="ident">proc_macro_derive</span>(<span class="ident">Deserialize</span>, <span class="ident">attributes</span>(<span class="ident">serde</span>))]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">derive_deserialize</span>(<span class="ident">input</span>: <span class="ident">TokenStream</span>) -&gt; <span class="ident">TokenStream</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">input</span> <span class="op">=</span> <span class="macro">parse_macro_input!</span>(<span class="ident">input</span> <span class="kw">as</span> <span class="ident">DeriveInput</span>);
    <span class="ident">de::expand_derive_deserialize</span>(<span class="kw-2">&amp;mut</span> <span class="ident">input</span>)
        .<span class="ident">unwrap_or_else</span>(<span class="ident">to_compile_errors</span>)
        .<span class="ident">into</span>()
}

<span class="kw">fn</span> <span class="ident">to_compile_errors</span>(<span class="ident">errors</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">syn::Error</span><span class="op">&gt;</span>) -&gt; <span class="ident">proc_macro2::TokenStream</span> {
    <span class="kw">let</span> <span class="ident">compile_errors</span> <span class="op">=</span> <span class="ident">errors</span>.<span class="ident">iter</span>().<span class="ident">map</span>(<span class="ident">syn::Error::to_compile_error</span>);
    <span class="macro">quote!</span>(#(#<span class="ident">compile_errors</span>)<span class="kw-2">*</span>)
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="serde_derive" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>